import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

export default function (_ref) {
  var repository = _ref.repository;

  var loadDefaultConsents = function loadDefaultConsents(_ref2) {
    var repository = _ref2.repository;
    return repository.getPurposesAndVendors().then(function (purposesAndVendors) {
      return _objectSpread({}, purposesAndVendors, {}, generateDefaultConsentsObject(purposesAndVendors));
    });
  };

  var loadStoredConsents = function loadStoredConsents(_ref3) {
    var repository = _ref3.repository;
    return Promise.all([repository.getPurposesAndVendors(), repository.getVendorConsents()]).then(function (_ref4) {
      var purposesAndVendors = _ref4[0],
          consents = _ref4[1];
      return _objectSpread({}, purposesAndVendors, {
        purposeConsents: consents.purposeConsents,
        vendorConsents: consents.vendorConsents
      });
    })["catch"](loadDefaultConsents);
  };

  var generateConsent = function generateConsent(_ref5) {
    var list = _ref5.list;
    return list.reduce(function (acc, _ref6) {
      var id = _ref6.id;
      acc[id.toString()] = true;
      return acc;
    }, {});
  };

  var generateDefaultConsentsObject = function generateDefaultConsentsObject(_ref7) {
    var purposes = _ref7.purposes,
        vendors = _ref7.vendors;
    return {
      purposeConsents: generateConsent({
        list: purposes
      }),
      vendorConsents: generateConsent({
        list: vendors
      })
    };
  };

  return {
    execute: function execute(_temp) {
      var _ref8 = _temp === void 0 ? {} : _temp,
          retrieveConsentsFromCmp = _ref8.retrieveConsentsFromCmp;

      return Promise.resolve(retrieveConsentsFromCmp).then(function (retrieve) {
        return retrieve ? loadStoredConsents({
          repository: repository
        }) : loadDefaultConsents({
          repository: repository
        });
      });
    }
  };
}